#pragma once

#include <Arduino.h>

#include "nmtypes.h"
#include "NetworkManagerAp.h"
#include "NetworkManagerSta.h"

#ifndef NM_WEB_DISABLED
    #include "WebManager.h"
#endif

class NetworkManager : public NetworkManagerAp, public NetworkManagerSta
#ifndef NM_WEB_DISABLED
, public NetworkWebManager
#endif
{
    public:
        NetworkManager();

        /**
         * Startup function to call all active modules to initialize
         */
        void begin();

        /**
         * Start all interfaces
         */
        void start();

        /**
         * Loop function to make sure everything works as expected
         */
        void loop();

        /**
         * SetHostname sets the hostname of the system used by all network communications
         * Set this before begin()
         */
        void setHostname(const char* hostname);
        /**
         * SetHostnamePrefix sets the prefix for generated hostnames (including separators when wanted)
         * only effective if hostname is not overriden / set
         * @param prefix
         */
        void setHostnamePrefix(const char* prefix);
        /**
         * SetHostnameSuffix sets the autogenerated part of a hostname
         * override this before begin() if you want to override the auto-generated hostname
         * @param hostname
         */
        void setHostnameSuffix(const char *hostname);

        const char *getHostname();

        bool isModeActive(NM_MODE_ENUM mode);

    protected:
        String hostname;
        String hostnamePrefix = "ESP-";
        String hostnameSuffix;
        byte activeModes;

        void setMode(NM_MODE_ENUM mode, bool state);
};

extern NetworkManager networkManager;
